package com.ruoyi.system.domain.task;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TkCommonDiaoduExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public TkCommonDiaoduExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andDdNameIsNull() {
            addCriterion("dd_name is null");
            return (Criteria) this;
        }

        public Criteria andDdNameIsNotNull() {
            addCriterion("dd_name is not null");
            return (Criteria) this;
        }

        public Criteria andDdNameEqualTo(String value) {
            addCriterion("dd_name =", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameNotEqualTo(String value) {
            addCriterion("dd_name <>", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameGreaterThan(String value) {
            addCriterion("dd_name >", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameGreaterThanOrEqualTo(String value) {
            addCriterion("dd_name >=", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameLessThan(String value) {
            addCriterion("dd_name <", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameLessThanOrEqualTo(String value) {
            addCriterion("dd_name <=", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameLike(String value) {
            addCriterion("dd_name like", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameNotLike(String value) {
            addCriterion("dd_name not like", value, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameIn(List<String> values) {
            addCriterion("dd_name in", values, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameNotIn(List<String> values) {
            addCriterion("dd_name not in", values, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameBetween(String value1, String value2) {
            addCriterion("dd_name between", value1, value2, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdNameNotBetween(String value1, String value2) {
            addCriterion("dd_name not between", value1, value2, "ddName");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiIsNull() {
            addCriterion("dd_youxianji is null");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiIsNotNull() {
            addCriterion("dd_youxianji is not null");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiEqualTo(String value) {
            addCriterion("dd_youxianji =", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiNotEqualTo(String value) {
            addCriterion("dd_youxianji <>", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiGreaterThan(String value) {
            addCriterion("dd_youxianji >", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiGreaterThanOrEqualTo(String value) {
            addCriterion("dd_youxianji >=", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiLessThan(String value) {
            addCriterion("dd_youxianji <", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiLessThanOrEqualTo(String value) {
            addCriterion("dd_youxianji <=", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiLike(String value) {
            addCriterion("dd_youxianji like", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiNotLike(String value) {
            addCriterion("dd_youxianji not like", value, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiIn(List<String> values) {
            addCriterion("dd_youxianji in", values, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiNotIn(List<String> values) {
            addCriterion("dd_youxianji not in", values, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiBetween(String value1, String value2) {
            addCriterion("dd_youxianji between", value1, value2, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdYouxianjiNotBetween(String value1, String value2) {
            addCriterion("dd_youxianji not between", value1, value2, "ddYouxianji");
            return (Criteria) this;
        }

        public Criteria andDdAddressIsNull() {
            addCriterion("dd_address is null");
            return (Criteria) this;
        }

        public Criteria andDdAddressIsNotNull() {
            addCriterion("dd_address is not null");
            return (Criteria) this;
        }

        public Criteria andDdAddressEqualTo(String value) {
            addCriterion("dd_address =", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressNotEqualTo(String value) {
            addCriterion("dd_address <>", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressGreaterThan(String value) {
            addCriterion("dd_address >", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressGreaterThanOrEqualTo(String value) {
            addCriterion("dd_address >=", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressLessThan(String value) {
            addCriterion("dd_address <", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressLessThanOrEqualTo(String value) {
            addCriterion("dd_address <=", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressLike(String value) {
            addCriterion("dd_address like", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressNotLike(String value) {
            addCriterion("dd_address not like", value, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressIn(List<String> values) {
            addCriterion("dd_address in", values, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressNotIn(List<String> values) {
            addCriterion("dd_address not in", values, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressBetween(String value1, String value2) {
            addCriterion("dd_address between", value1, value2, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdAddressNotBetween(String value1, String value2) {
            addCriterion("dd_address not between", value1, value2, "ddAddress");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiIsNull() {
            addCriterion("dd_zhipaidanwei is null");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiIsNotNull() {
            addCriterion("dd_zhipaidanwei is not null");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiEqualTo(String value) {
            addCriterion("dd_zhipaidanwei =", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiNotEqualTo(String value) {
            addCriterion("dd_zhipaidanwei <>", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiGreaterThan(String value) {
            addCriterion("dd_zhipaidanwei >", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiGreaterThanOrEqualTo(String value) {
            addCriterion("dd_zhipaidanwei >=", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiLessThan(String value) {
            addCriterion("dd_zhipaidanwei <", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiLessThanOrEqualTo(String value) {
            addCriterion("dd_zhipaidanwei <=", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiLike(String value) {
            addCriterion("dd_zhipaidanwei like", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiNotLike(String value) {
            addCriterion("dd_zhipaidanwei not like", value, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiIn(List<String> values) {
            addCriterion("dd_zhipaidanwei in", values, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiNotIn(List<String> values) {
            addCriterion("dd_zhipaidanwei not in", values, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiBetween(String value1, String value2) {
            addCriterion("dd_zhipaidanwei between", value1, value2, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdZhipaidanweiNotBetween(String value1, String value2) {
            addCriterion("dd_zhipaidanwei not between", value1, value2, "ddZhipaidanwei");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianIsNull() {
            addCriterion("dd_chulishixian is null");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianIsNotNull() {
            addCriterion("dd_chulishixian is not null");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianEqualTo(Date value) {
            addCriterionForJDBCDate("dd_chulishixian =", value, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianNotEqualTo(Date value) {
            addCriterionForJDBCDate("dd_chulishixian <>", value, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianGreaterThan(Date value) {
            addCriterionForJDBCDate("dd_chulishixian >", value, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("dd_chulishixian >=", value, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianLessThan(Date value) {
            addCriterionForJDBCDate("dd_chulishixian <", value, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("dd_chulishixian <=", value, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianIn(List<Date> values) {
            addCriterionForJDBCDate("dd_chulishixian in", values, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianNotIn(List<Date> values) {
            addCriterionForJDBCDate("dd_chulishixian not in", values, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("dd_chulishixian between", value1, value2, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdChulishixianNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("dd_chulishixian not between", value1, value2, "ddChulishixian");
            return (Criteria) this;
        }

        public Criteria andDdTkidIsNull() {
            addCriterion("dd_tkid is null");
            return (Criteria) this;
        }

        public Criteria andDdTkidIsNotNull() {
            addCriterion("dd_tkid is not null");
            return (Criteria) this;
        }

        public Criteria andDdTkidEqualTo(String value) {
            addCriterion("dd_tkid =", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidNotEqualTo(String value) {
            addCriterion("dd_tkid <>", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidGreaterThan(String value) {
            addCriterion("dd_tkid >", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidGreaterThanOrEqualTo(String value) {
            addCriterion("dd_tkid >=", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidLessThan(String value) {
            addCriterion("dd_tkid <", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidLessThanOrEqualTo(String value) {
            addCriterion("dd_tkid <=", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidLike(String value) {
            addCriterion("dd_tkid like", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidNotLike(String value) {
            addCriterion("dd_tkid not like", value, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidIn(List<String> values) {
            addCriterion("dd_tkid in", values, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidNotIn(List<String> values) {
            addCriterion("dd_tkid not in", values, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidBetween(String value1, String value2) {
            addCriterion("dd_tkid between", value1, value2, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdTkidNotBetween(String value1, String value2) {
            addCriterion("dd_tkid not between", value1, value2, "ddTkid");
            return (Criteria) this;
        }

        public Criteria andDdStatusIsNull() {
            addCriterion("dd_status is null");
            return (Criteria) this;
        }

        public Criteria andDdStatusIsNotNull() {
            addCriterion("dd_status is not null");
            return (Criteria) this;
        }

        public Criteria andDdStatusEqualTo(String value) {
            addCriterion("dd_status =", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusNotEqualTo(String value) {
            addCriterion("dd_status <>", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusGreaterThan(String value) {
            addCriterion("dd_status >", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusGreaterThanOrEqualTo(String value) {
            addCriterion("dd_status >=", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusLessThan(String value) {
            addCriterion("dd_status <", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusLessThanOrEqualTo(String value) {
            addCriterion("dd_status <=", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusLike(String value) {
            addCriterion("dd_status like", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusNotLike(String value) {
            addCriterion("dd_status not like", value, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusIn(List<String> values) {
            addCriterion("dd_status in", values, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusNotIn(List<String> values) {
            addCriterion("dd_status not in", values, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusBetween(String value1, String value2) {
            addCriterion("dd_status between", value1, value2, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdStatusNotBetween(String value1, String value2) {
            addCriterion("dd_status not between", value1, value2, "ddStatus");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeIsNull() {
            addCriterion("dd_createtime is null");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeIsNotNull() {
            addCriterion("dd_createtime is not null");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeEqualTo(Date value) {
            addCriterion("dd_createtime =", value, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeNotEqualTo(Date value) {
            addCriterion("dd_createtime <>", value, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeGreaterThan(Date value) {
            addCriterion("dd_createtime >", value, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("dd_createtime >=", value, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeLessThan(Date value) {
            addCriterion("dd_createtime <", value, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeLessThanOrEqualTo(Date value) {
            addCriterion("dd_createtime <=", value, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeIn(List<Date> values) {
            addCriterion("dd_createtime in", values, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeNotIn(List<Date> values) {
            addCriterion("dd_createtime not in", values, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeBetween(Date value1, Date value2) {
            addCriterion("dd_createtime between", value1, value2, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdCreatetimeNotBetween(Date value1, Date value2) {
            addCriterion("dd_createtime not between", value1, value2, "ddCreatetime");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusIsNull() {
            addCriterion("dd_tkstatus is null");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusIsNotNull() {
            addCriterion("dd_tkstatus is not null");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusEqualTo(String value) {
            addCriterion("dd_tkstatus =", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusNotEqualTo(String value) {
            addCriterion("dd_tkstatus <>", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusGreaterThan(String value) {
            addCriterion("dd_tkstatus >", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusGreaterThanOrEqualTo(String value) {
            addCriterion("dd_tkstatus >=", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusLessThan(String value) {
            addCriterion("dd_tkstatus <", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusLessThanOrEqualTo(String value) {
            addCriterion("dd_tkstatus <=", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusLike(String value) {
            addCriterion("dd_tkstatus like", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusNotLike(String value) {
            addCriterion("dd_tkstatus not like", value, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusIn(List<String> values) {
            addCriterion("dd_tkstatus in", values, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusNotIn(List<String> values) {
            addCriterion("dd_tkstatus not in", values, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusBetween(String value1, String value2) {
            addCriterion("dd_tkstatus between", value1, value2, "ddTkstatus");
            return (Criteria) this;
        }

        public Criteria andDdTkstatusNotBetween(String value1, String value2) {
            addCriterion("dd_tkstatus not between", value1, value2, "ddTkstatus");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}